#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <malloc.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>
#include <stdio.h>


int create_socket( int port ) {
	int i, size;
	int s, flag;
	struct sockaddr_in serv_addr; /* internet endpoint address */
        struct sockaddr    *ptr_serv_addr;
	int socket_descriptor;

	if(port <= 7000 || port >= 20000) {
		printf("Danger! port number bad: %d\n", port);
		return NULL;
	}


/* Align pointers, get sizes, zero things */

        size		= sizeof(serv_addr);
        ptr_serv_addr	= (struct sockaddr    *) &serv_addr;
        bzero( (char*) ptr_serv_addr, size);

/* Begin to create a socket name */

	serv_addr.sin_family = AF_INET;
	serv_addr.sin_port = port;
	
/* Open the socket */

	s = socket(AF_INET, SOCK_STREAM, 0);
	if(s < 0) {
		printf("server cannot open socket\n");
		printf("return from socket call = %d\n",s);
		return NULL;
	}


/* Bind to the socket */

	flag = bind(s, ptr_serv_addr, size);
	if(flag < 0) {
		printf("server cannot bind to socket\n");
		printf("return from bind call = %d\n",flag);
		return NULL;
	}


/* Define the number of listeners */

        flag = listen(s, 1);
	if(flag < 0) {  
                printf("can't listen on port");
                printf("return from listen call = %d",flag);
               	return NULL; 
        }                

	printf("waiting for client to connect on port %d\n", port);

/* Accept connection to client */

        socket_descriptor  = accept(s, ptr_serv_addr, &size);
	printf("connection made\n");
       	if( socket_descriptor  < 0) {
		printf("failed to accept, return = %d\n",socket_descriptor);
		return NULL;
        }
	return socket_descriptor;
}




